//
//  ViewController.swift
//  CastlabsDASHDemo
//
//

import PRESTOplay
import CastlabsVT
import AVFoundation
import UIKit

class ViewController: UIViewController {
    // create player instance
    var player = PRESTOplaySDK.shared.player()

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        // optional: ignore silent switch
        try? AVAudioSession.sharedInstance().setCategory(.playback)

        /// Clear:
        /// https://demo.cf.castlabs.com/media/TOS/abr/Manifest_clean_sizes.mpd?v=10
        ///
        guard let contentURL =
            URL(
                string: "https://demo.cf.castlabs.com/media/TOS/abr/Manifest_clean_sizes.mpd?v=10")
        else { return }

        let config = PlayerConfiguration(with: contentURL)

        /// ABR configuration
        /*
        config.abrConfiguration = AbrConfiguration()
        config.abrConfiguration?.minDurationForQualityIncreaseMs = 3 * 1000
        config.abrConfiguration?.maxInitialBitrate = 500_000
        */

        /// Buffer configuration
        /*
        player.minPrebufferTime = 6.0
        player.maxPrebufferTime = 60.0
        player.minRebufferTime = 12.0
        */

        /// Live configuration
        /*
        player.liveEdgeDelay = 6.0
        player.chaseLiveEdge = .speedupPlayback
        player.chaseLiveEdgeCatchupThreshold = 3.0
        player.chaseLiveEdgeCutoffThreshold = 2.0
        player.chaseLiveEdgeHLSSegmentDuration = 10.0
        player.chaseLiveEdgeSpeedupRatio = 1.2
        */

        player.load(config: config)

        player.onState = { [weak self] previous, state in
            guard let self else { return }
            if let error = player.error {
                print("Error \(error)")
            }
        }

        player.attach(to: view.layer)
        player.open(autoplay: true)
    }

    override func viewWillTransition(to size: CGSize,
                                     with coordinator: UIViewControllerTransitionCoordinator) {
        player.update(size: size)
    }
}
